Loading...
Searching...
No Matches
Globus XIO API
Globus XIO

Globus XIO API. More...

## Typedefs

typedef void(* | globus_xio_accept_callback_t) (globus_xio_server_t server, globus_xio_handle_t handle, globus_result_t result, void *user_arg)
typedef void(* | globus_xio_server_callback_t) (globus_xio_server_t server, void *user_arg)
typedef globus_bool_t(* | globus_xio_timeout_callback_t) (globus_xio_handle_t handle, globus_xio_operation_type_t type, void *user_arg)
typedef void(* | globus_xio_callback_t) (globus_xio_handle_t handle, globus_result_t result, void *user_arg)
typedef void(* | globus_xio_data_callback_t) (globus_xio_handle_t handle, globus_result_t result, globus_byte_t *buffer, globus_size_t len, globus_size_t nbytes, globus_xio_data_descriptor_t data_desc, void *user_arg)
typedef void(* | globus_xio_iovec_callback_t) (globus_xio_handle_t handle, globus_result_t result, globus_xio_iovec_t *iovec, int count, globus_size_t nbytes, globus_xio_data_descriptor_t data_desc, void *user_arg)
typedef enum globus_i_xio_op_type_e | globus_xio_operation_type_t

## Enumerations

enum | globus_i_xio_op_type_e
enum | globus_xio_handle_cmd_t { GLOBUS_XIO_GET_LOCAL_CONTACT = 12345 , GLOBUS_XIO_GET_LOCAL_NUMERIC_CONTACT , GLOBUS_XIO_GET_REMOTE_CONTACT , GLOBUS_XIO_GET_REMOTE_NUMERIC_CONTACT , GLOBUS_XIO_SEEK , GLOBUS_XIO_SET_STRING_OPTIONS , GLOBUS_XIO_GET_STRING_OPTIONS , GLOBUS_XIO_GET_DRIVER_NAME }

## Functions

globus_result_t | globus_xio_attr_init (globus_xio_attr_t *attr)
globus_result_t | globus_xio_attr_cntl (globus_xio_attr_t attr, globus_xio_driver_t driver, int cmd,...)
globus_result_t | globus_xio_attr_copy (globus_xio_attr_t *dst, globus_xio_attr_t src)
globus_result_t | globus_xio_attr_destroy (globus_xio_attr_t attr)
globus_result_t | globus_xio_stack_init (globus_xio_stack_t *stack, globus_xio_attr_t stack_attr)
globus_result_t | globus_xio_stack_push_driver (globus_xio_stack_t stack, globus_xio_driver_t driver)
globus_result_t | globus_xio_stack_copy (globus_xio_stack_t *dst, globus_xio_stack_t src)
globus_result_t | globus_xio_stack_destroy (globus_xio_stack_t stack)
globus_result_t | globus_xio_server_create (globus_xio_server_t *server, globus_xio_attr_t server_attr, globus_xio_stack_t stack)
globus_result_t | globus_xio_server_get_contact_string (globus_xio_server_t server, char **contact_string)
globus_result_t | globus_xio_server_register_close (globus_xio_server_t server, globus_xio_server_callback_t cb, void *user_arg)
globus_result_t | globus_xio_server_close (globus_xio_server_t server)
globus_result_t | globus_xio_server_cntl (globus_xio_server_t server, globus_xio_driver_t driver, int cmd,...)
globus_result_t | globus_xio_server_accept (globus_xio_handle_t *out_handle, globus_xio_server_t server)
globus_result_t | globus_xio_server_register_accept (globus_xio_server_t server, globus_xio_accept_callback_t cb, void *user_arg)
globus_result_t | globus_xio_handle_create (globus_xio_handle_t *handle, globus_xio_stack_t stack)
globus_result_t | globus_xio_data_descriptor_init (globus_xio_data_descriptor_t *data_desc, globus_xio_handle_t handle)
globus_result_t | globus_xio_data_descriptor_destroy (globus_xio_data_descriptor_t data_desc)
globus_result_t | globus_xio_data_descriptor_cntl (globus_xio_data_descriptor_t data_desc, globus_xio_driver_t driver, int cmd,...)
globus_result_t | globus_xio_handle_cntl (globus_xio_handle_t handle, globus_xio_driver_t driver, int cmd,...)
globus_result_t | globus_xio_register_open (globus_xio_handle_t handle, const char *contact_string, globus_xio_attr_t attr, globus_xio_callback_t cb, void *user_arg)
globus_result_t | globus_xio_open (globus_xio_handle_t handle, const char *contact_string, globus_xio_attr_t attr)
globus_result_t | globus_xio_register_read (globus_xio_handle_t handle, globus_byte_t *buffer, globus_size_t buffer_length, globus_size_t waitforbytes, globus_xio_data_descriptor_t data_desc, globus_xio_data_callback_t cb, void *user_arg)
globus_result_t | globus_xio_read (globus_xio_handle_t handle, globus_byte_t *buffer, globus_size_t buffer_length, globus_size_t waitforbytes, globus_size_t *nbytes, globus_xio_data_descriptor_t data_desc)
globus_result_t | globus_xio_register_readv (globus_xio_handle_t handle, globus_xio_iovec_t *iovec, int iovec_count, globus_size_t waitforbytes, globus_xio_data_descriptor_t data_desc, globus_xio_iovec_callback_t cb, void *user_arg)
globus_result_t | globus_xio_readv (globus_xio_handle_t handle, globus_xio_iovec_t *iovec, int iovec_count, globus_size_t waitforbytes, globus_size_t *nbytes, globus_xio_data_descriptor_t data_desc)
globus_result_t | globus_xio_register_write (globus_xio_handle_t handle, globus_byte_t *buffer, globus_size_t buffer_length, globus_size_t waitforbytes, globus_xio_data_descriptor_t data_desc, globus_xio_data_callback_t cb, void *user_arg)
globus_result_t | globus_xio_write (globus_xio_handle_t handle, globus_byte_t *buffer, globus_size_t buffer_length, globus_size_t waitforbytes, globus_size_t *nbytes, globus_xio_data_descriptor_t data_desc)
globus_result_t | globus_xio_register_writev (globus_xio_handle_t handle, globus_xio_iovec_t *iovec, int iovec_count, globus_size_t waitforbytes, globus_xio_data_descriptor_t data_desc, globus_xio_iovec_callback_t cb, void *user_arg)
globus_result_t | globus_xio_writev (globus_xio_handle_t handle, globus_xio_iovec_t *iovec, int iovec_count, globus_size_t waitforbytes, globus_size_t *nbytes, globus_xio_data_descriptor_t data_desc)
globus_result_t | globus_xio_register_close (globus_xio_handle_t handle, globus_xio_attr_t attr, globus_xio_callback_t cb, void *user_arg)
globus_result_t | globus_xio_close (globus_xio_handle_t handle, globus_xio_attr_t attr)
globus_result_t | globus_xio_handle_create_from_url (globus_xio_handle_t *out_h, const char *scheme, globus_xio_attr_t attr, char *param_string)
globus_result_t | globus_xio_driver_list_to_stack_attr (globus_list_t *driver_list, globus_xio_stack_t stack, globus_xio_attr_t attr)
| Add a list of driver entries to a stack.
globus_result_t | globus_xio_handle_cntl (handle, driver, GLOBUS_XIO_GET_LOCAL_CONTACT, char **contact_string_out)
globus_result_t | globus_xio_handle_cntl (handle, driver, GLOBUS_XIO_GET_LOCAL_NUMERIC_CONTACT, char **contact_string_out)
globus_result_t | globus_xio_handle_cntl (handle, driver, GLOBUS_XIO_GET_REMOTE_CONTACT, char **contact_string_out)
globus_result_t | globus_xio_handle_cntl (handle, driver, GLOBUS_XIO_GET_REMOTE_NUMERIC_CONTACT, char **contact_string_out)
globus_result_t | globus_xio_handle_cntl (handle, driver, GLOBUS_XIO_SEEK, globus_off_t offset)
globus_result_t | globus_xio_handle_cntl (handle, driver, GLOBUS_XIO_SET_STRING_OPTIONS, char *config_string)
globus_result_t | globus_xio_handle_cntl (handle, driver, GLOBUS_XIO_GET_STRING_OPTIONS, char **config_string)
globus_result_t | globus_xio_handle_cntl (handle, driver, GLOBUS_XIO_GET_DRIVER_NAME, const char **driver_name)

## Detailed Description

Globus XIO API.

## Typedef Documentation

## globus_xio_accept_callback_t

typedef void(* globus_xio_accept_callback_t) (globus_xio_server_t server, globus_xio_handle_t handle, globus_result_t result, void *user_arg)

Callback signature for accept.

When a registered accept operation completes the users function of this signature is called.

Parameters

  server | The server object on which the accept was registered.
  handle | The newly created handle that was created by the accept operation.
  result | A result code indicating the success of the accept operation. GLOBUS_SUCCESS indicates a successful accept.
  user_arg | A user argument that is threaded from the registration to the callback.

## globus_xio_callback_t

typedef void(* globus_xio_callback_t) (globus_xio_handle_t handle, globus_result_t result, void *user_arg)

globus_xio_callback_t

This callback is used for the open and close asynchronous operations.

## globus_xio_data_callback_t

typedef void(* globus_xio_data_callback_t) (globus_xio_handle_t handle, globus_result_t result, globus_byte_t *buffer, globus_size_t len, globus_size_t nbytes, globus_xio_data_descriptor_t data_desc, void *user_arg)

globus_xio_data_callback_t

This callback is used for asynchronous operations that send or receive data.

On EOF, result_t will be of type GLOBUS_XIO_ERROR_EOF

## globus_xio_iovec_callback_t

typedef void(* globus_xio_iovec_callback_t) (globus_xio_handle_t handle, globus_result_t result, globus_xio_iovec_t *iovec, int count, globus_size_t nbytes, globus_xio_data_descriptor_t data_desc, void *user_arg)

globus_xio_iovec_callback_t

This callback is used for asynchronous operations that send or receive data with an iovec structure.

On EOF, result_t will be of type GLOBUS_XIO_ERROR_EOF

## globus_xio_operation_type_t

typedef enum globus_i_xio_op_type_e globus_xio_operation_type_t

Operation types

An enumeration of operation types. Used in the timeout callback to indicate what operation typed timedout.

## globus_xio_server_callback_t

typedef void(* globus_xio_server_callback_t) (globus_xio_server_t server, void *user_arg)

Server callback signature.

This is the generic server callback signature. It is currently only used for the register close operation.

## globus_xio_timeout_callback_t

typedef globus_bool_t(* globus_xio_timeout_callback_t) (globus_xio_handle_t handle, globus_xio_operation_type_t type, void *user_arg)

The timeout callback function signature.

Parameters

  handle | The handle the handle on which the timeout operation was requested.
  type | The type of operation that timed out: GLOBUS_XIO_OPERATION_OPEN GLOBUS_XIO_OPERATION_CLOSE GLOBUS_XIO_OPERATION_READ GLOBUS_XIO_OPERATION_WRITE
  user_arg | A user arg threaded through to the callback.

## Enumeration Type Documentation

## globus_i_xio_op_type_e

enum globus_i_xio_op_type_e

Operation types

An enumeration of operation types. Used in the timeout callback to indicate what operation typed timedout.

## globus_xio_handle_cmd_t

enum globus_xio_handle_cmd_t

doxygen varargs filter stuff Common driver handle cntls.

Enumerator
GLOBUS_XIO_GET_LOCAL_CONTACT | See usage for: globus_xio_handle_cntl
GLOBUS_XIO_GET_LOCAL_NUMERIC_CONTACT | See usage for: globus_xio_handle_cntl
GLOBUS_XIO_GET_REMOTE_CONTACT | See usage for: globus_xio_handle_cntl
GLOBUS_XIO_GET_REMOTE_NUMERIC_CONTACT | See usage for: globus_xio_handle_cntl
GLOBUS_XIO_SEEK | See usage for: globus_xio_handle_cntl
GLOBUS_XIO_SET_STRING_OPTIONS | See usage for: globus_xio_handle_cntl
GLOBUS_XIO_GET_STRING_OPTIONS | See usage for: globus_xio_handle_cntl
GLOBUS_XIO_GET_DRIVER_NAME | See usage for: globus_xio_handle_cntl

## Function Documentation

## globus_xio_attr_cntl()

globus_result_t globus_xio_attr_cntl | ( | globus_xio_attr_t | attr,
|  | globus_xio_driver_t | driver,
|  | int | cmd,
|  |  | ... )

Manipulate the values associated in the attr.

This function provides a means to access the attr structure. What exactly this function does is determined by the value in the parameter cmd and the value of the parameter driver. When the driver parameter is NULL it indicates that this function applies to general Globus XIO values. If it is not NULL it indicates that the function will effect driver specific values. Each driver is responsible for defining its own enumeration of values for cmd and the var args associated with that command.

Parameters

  attr | the attribute structure to be manipulated.
  driver | This parameter indicates which driver the user would like to perform the requested operation. If this parameter is NULL this request will be scoped to general attribute functions.
  cmd | an enum that determines what specific operation the user is requesting. Each driver will determine the value for this enumeration.

## globus_xio_attr_copy()

globus_result_t globus_xio_attr_copy | ( | globus_xio_attr_t * | dst,
|  | globus_xio_attr_t | src )

Copy an attribute structure.

## globus_xio_attr_destroy()

globus_result_t globus_xio_attr_destroy | ( | globus_xio_attr_t | attr | ) |

Clean up resources associated with an attribute.

Parameters

  attr | Upon completion of this function all resources associated with this structure will returned to the system and the attr will no longer be valid.

## globus_xio_attr_init()

globus_result_t globus_xio_attr_init | ( | globus_xio_attr_t * | attr | ) |

Initialize a Globus XIO attribute.

Parameters

  attr | upon return from this function this out parameter will be initialized. Once the user is finished with the attribute they should make sure they destroy it in order to free resources associated with it.

## globus_xio_close()

globus_result_t globus_xio_close | ( | globus_xio_handle_t | handle,
|  | globus_xio_attr_t | attr )

Blocking close

## globus_xio_data_descriptor_cntl()

globus_result_t globus_xio_data_descriptor_cntl | ( | globus_xio_data_descriptor_t | data_desc,
|  | globus_xio_driver_t | driver,
|  | int | cmd,
|  |  | ... )

Touch driver specific data in data descriptors

This function allows the user to communicate directly with a driver in association with a data descriptors. The driver defines what operations can be preformed.

## globus_xio_data_descriptor_destroy()

globus_result_t globus_xio_data_descriptor_destroy | ( | globus_xio_data_descriptor_t | data_desc | ) |

clean up a data descriptor.

## globus_xio_data_descriptor_init()

globus_result_t globus_xio_data_descriptor_init | ( | globus_xio_data_descriptor_t * | data_desc,
|  | globus_xio_handle_t | handle )

Initialize a data descriptor

Parameters

  data_desc | An out parameter. The data descriptor to be initialized.
  handle | The handle this data descriptor will be used with. This parameter is require in order to optimize the code handling the data descriptors use.

## globus_xio_driver_list_to_stack_attr()

globus_result_t globus_xio_driver_list_to_stack_attr | ( | globus_list_t * | driver_list,
|  | globus_xio_stack_t | stack,
|  | globus_xio_attr_t | attr )

Add a list of driver entries to a stack.

This function walks a list of `globus_xio_driver_list_ent_t *` values passed as the driver_list parameter, and pushes them onto the XIO stack passed as the stack parameter and sets attributes for those drivers in the attr passed as the attr parameter to this function.

Parameters

  driver_list | A list of driver list entries in stack order (transport, followed by transform). Each entry may contain a option string for attributes to set for this driver.
  stack | A pointer to an XIO stack which will have the drivers pushed onto. It must be previously initialized by calling globus_xio_stack_init(). This function does not overwrite the stack, so the drivers passed in the driver list will be pushed on top of any existing drivers in the stack.
  attr | A pointer to an XIO attribute which will have the driver-specific string options set on it, after the drivers are pushed onto the stack. The opts field of the list entries are passed to the GLOBUS_XIO_SET_STRING_OPTIONS attr control function. This value must be previously initialized by calling globus_xio_attr_init(). Errors from the attr control function are ignored.

Returns
  If the driver can not be pushed onto the stack, an error result is returned; otherwise, GLOBUS_SUCCESS. If an error occurs, some of the entries MAY be pushed on to the stack and some attributes may have been set in the attr. Both should be destroyed by the caller.

## globus_xio_handle_cntl() [1/9]

globus_result_t globus_xio_handle_cntl | ( | globus_xio_handle_t | handle,
|  | globus_xio_driver_t | driver,
|  | int | cmd,
|  |  | ... )

Touch driver specific information in a handle object.

This function allows the user to communicate directly with a driver in association with a handle object. The driver defines what operations can be preformed.

pass the driver to control a specific driver pass NULL for driver for XIO specific cntls pass GLOBUS_XIO_QUERY for driver to try each driver in order until success

## globus_xio_handle_cntl() [2/9]

globus_result_t globus_xio_handle_cntl | ( | handle | ,
|  | driver | ,
|  | GLOBUS_XIO_GET_DRIVER_NAME | ,
|  | const char ** | driver_name )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Set the driver specific configuration string. The format of the string is defined by the driver. It is typically a set of key=value pairs

Parameters

  driver_name | The driver name.

## globus_xio_handle_cntl() [3/9]

globus_result_t globus_xio_handle_cntl | ( | handle | ,
|  | driver | ,
|  | GLOBUS_XIO_GET_LOCAL_CONTACT | ,
|  | char ** | contact_string_out )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Get local connection info.

Parameters

  contact_string_out | A pointer to a contact string for the local end of a connected handle. Where possible, it will be in symbolic form (FQDN).

The user must free the returned string.

See also
  globus_xio_server_get_contact_string()

## globus_xio_handle_cntl() [4/9]

globus_result_t globus_xio_handle_cntl | ( | handle | ,
|  | driver | ,
|  | GLOBUS_XIO_GET_LOCAL_NUMERIC_CONTACT | ,
|  | char ** | contact_string_out )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Get local connection info.

Parameters

  contact_string_out | A pointer to a contact string for the local end of a connected handle. Where possible, it will be in numeric form. (IP)

The user must free the returned string.

## globus_xio_handle_cntl() [5/9]

globus_result_t globus_xio_handle_cntl | ( | handle | ,
|  | driver | ,
|  | GLOBUS_XIO_GET_REMOTE_CONTACT | ,
|  | char ** | contact_string_out )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Get remote connection info.

Parameters

  contact_string_out | A pointer to a contact string for the remote end of a connected handle. Where possible, it will be in symbolic form (FQDN).

The user must free the returned string.

## globus_xio_handle_cntl() [6/9]

globus_result_t globus_xio_handle_cntl | ( | handle | ,
|  | driver | ,
|  | GLOBUS_XIO_GET_REMOTE_NUMERIC_CONTACT | ,
|  | char ** | contact_string_out )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Get remote connection info.

Parameters

  contact_string_out | A pointer to a contact string for the remote end of a connected handle. Where possible, it will be in numeric form. (IP)

The user must free the returned string.

## globus_xio_handle_cntl() [7/9]

globus_result_t globus_xio_handle_cntl | ( | handle | ,
|  | driver | ,
|  | GLOBUS_XIO_GET_STRING_OPTIONS | ,
|  | char ** | config_string )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Set the driver specific configuration string. The format of the string is defined by the driver. It is typically a set of key=value pairs

Parameters

  config_string | The driver specific parameter string.

## globus_xio_handle_cntl() [8/9]

globus_result_t globus_xio_handle_cntl | ( | handle | ,
|  | driver | ,
|  | GLOBUS_XIO_SEEK | ,
|  | globus_off_t | offset )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Reposition read/write offset.

Parameters

  offset | Specify the desired offset.

## globus_xio_handle_cntl() [9/9]

globus_result_t globus_xio_handle_cntl | ( | handle | ,
|  | driver | ,
|  | GLOBUS_XIO_SET_STRING_OPTIONS | ,
|  | char * | config_string )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Set the driver specific configuration string. The format of the string is defined by the driver. It is typically a set of key=value pairs

Parameters

  config_string | The driver specific parameter string.

## globus_xio_handle_create()

globus_result_t globus_xio_handle_create | ( | globus_xio_handle_t * | handle,
|  | globus_xio_stack_t | stack )

Initialize a handle for client opens

This function will initialize a handle for active opens (client side connections).

## globus_xio_handle_create_from_url()

globus_result_t globus_xio_handle_create_from_url | ( | globus_xio_handle_t * | out_h,
|  | const char * | scheme,
|  | globus_xio_attr_t | attr,
|  | char * | param_string )

Initializes a handle based on the scheme given.

Parameters

  out_h | An uninitialized handle that will be initialized in the function to correspond to the scheme given. This handle should be used for any I/O operations.
  scheme | A string containing the protocol which the handle should be initialized to. The string can either be a protocol by itself, for example, "http", or a complete scheme such as "http://www.example.com".
  attr | Attribute to be used for setting parameter string. It is initialized by the function. Can be NULL if attributes are not being used.
  param_string | A string containing attributes to be set for the drivers associated with the scheme. This should be in the form "protocol1:option1=value1;option2=value2,protocol2:option1=value1; option2=value2" Can be NULL if attributes are not being used.

## globus_xio_open()

globus_result_t globus_xio_open | ( | globus_xio_handle_t | handle,
|  | const char * | contact_string,
|  | globus_xio_attr_t | attr )

Blocking open

## globus_xio_read()

globus_result_t globus_xio_read | ( | globus_xio_handle_t | handle,
|  | globus_byte_t * | buffer,
|  | globus_size_t | buffer_length,
|  | globus_size_t | waitforbytes,
|  | globus_size_t * | nbytes,
|  | globus_xio_data_descriptor_t | data_desc )

Read data from a handle

## globus_xio_readv()

globus_result_t globus_xio_readv | ( | globus_xio_handle_t | handle,
|  | globus_xio_iovec_t * | iovec,
|  | int | iovec_count,
|  | globus_size_t | waitforbytes,
|  | globus_size_t * | nbytes,
|  | globus_xio_data_descriptor_t | data_desc )

Read data from a handle into a globus_xio_iovec_t (struct iovec)

## globus_xio_register_close()

globus_result_t globus_xio_register_close | ( | globus_xio_handle_t | handle,
|  | globus_xio_attr_t | attr,
|  | globus_xio_callback_t | cb,
|  | void * | user_arg )

Close a handle

This functions servers as a destroy for the handle. As soon as the operations completes (the callback is called). The handle is destroyed.

Parameters

  handle | the handle to be closed.
  attr | how to close attribute
  cb | The function to be called when the close operation completes.
  user_arg | A user pointer that will be threaded through to the callback.

## globus_xio_register_open()

globus_result_t globus_xio_register_open | ( | globus_xio_handle_t | handle,
|  | const char * | contact_string,
|  | globus_xio_attr_t | attr,
|  | globus_xio_callback_t | cb,
|  | void * | user_arg )

Open a handle

Creates an open handle based on the state contained in the given stack.

No operation can be preformed on a handle until it is initialized and then opened. If an already open handle used the information contained in that handle will be destroyed.

Parameters

  handle | The handle created with globus_xio_handle_create() or globus_xio_server_register_accept() that is to be opened.
  attr | how to open attribute. can be NULL
  cb | The function to be called when the open operation completes.
  user_arg | A user pointer that will be threaded through to the callback.
  contact_string | An url describing the resource. NULL is allowed. Drivers interpret the various parts of this url as described in their documentation. An alternative form is also supported: if contact_string does not specify a scheme (e.g. http://) and it contains a ':', it will be parsed as a host:port pair. if it does not contain a ':', it will be parsed as the path

the following are examples of valid formats:

       <path to file>
       host-name ":" <service or port>
       "file:" <path to file>
       <scheme> "://" [ "/" [ <path to resource> ]  ]
       <scheme> "://" location [ "/" [ <path to resource> ] ]
         location:
             [ auth-part ] host-part
         auth-part:
             <user> [ ":" <password> ] "@"
         host-part:
             [ "<" <subject> ">" ] host-name [ ":" <port or service> ]
         host-name:
             <hostname> | <dotted quad> | "[" <ipv6 address> "]"

Except for use as the above delimiters, the following special characters MUST be encoded with the %HH format where H == hex char.

       "/" and "@" in location except subject
       "<" and ">" in location
       ":" everywhere except ipv6 address and subject
       "%" everywhere (can be encoded with %HH or %%)

## globus_xio_register_read()

globus_result_t globus_xio_register_read | ( | globus_xio_handle_t | handle,
|  | globus_byte_t * | buffer,
|  | globus_size_t | buffer_length,
|  | globus_size_t | waitforbytes,
|  | globus_xio_data_descriptor_t | data_desc,
|  | globus_xio_data_callback_t | cb,
|  | void * | user_arg )

Read data from a handle

## globus_xio_register_readv()

globus_result_t globus_xio_register_readv | ( | globus_xio_handle_t | handle,
|  | globus_xio_iovec_t * | iovec,
|  | int | iovec_count,
|  | globus_size_t | waitforbytes,
|  | globus_xio_data_descriptor_t | data_desc,
|  | globus_xio_iovec_callback_t | cb,
|  | void * | user_arg )

Read data from a handle into a globus_xio_iovec_t (struct iovec)

## globus_xio_register_write()

globus_result_t globus_xio_register_write | ( | globus_xio_handle_t | handle,
|  | globus_byte_t * | buffer,
|  | globus_size_t | buffer_length,
|  | globus_size_t | waitforbytes,
|  | globus_xio_data_descriptor_t | data_desc,
|  | globus_xio_data_callback_t | cb,
|  | void * | user_arg )

Write data to a handle

## globus_xio_register_writev()

globus_result_t globus_xio_register_writev | ( | globus_xio_handle_t | handle,
|  | globus_xio_iovec_t * | iovec,
|  | int | iovec_count,
|  | globus_size_t | waitforbytes,
|  | globus_xio_data_descriptor_t | data_desc,
|  | globus_xio_iovec_callback_t | cb,
|  | void * | user_arg )

Write data to a handle from a globus_xio_iovec_t (struct iovec)

## globus_xio_server_accept()

globus_result_t globus_xio_server_accept | ( | globus_xio_handle_t * | out_handle,
|  | globus_xio_server_t | server )

Accept a connection

This function will accept a connection on the given server object and the parameter out_handle will be valid if the function returns successfully.

## globus_xio_server_close()

globus_result_t globus_xio_server_close | ( | globus_xio_server_t | server | ) |

A blocking server close

## globus_xio_server_cntl()

globus_result_t globus_xio_server_cntl | ( | globus_xio_server_t | server,
|  | globus_xio_driver_t | driver,
|  | int | cmd,
|  |  | ... )

Touch driver specific information in a server object.

This function allows the user to communicate directly with a driver in association with a server object. The driver defines what operations can be preformed.

## globus_xio_server_create()

globus_result_t globus_xio_server_create | ( | globus_xio_server_t * | server,
|  | globus_xio_attr_t | server_attr,
|  | globus_xio_stack_t | stack )

Create a server object.

This function allows the user to create a server object which can then be used to accept connections.

Parameters

  server | An out parameter. Once the function successfully returns this will point to a valid server object.
  server_attr | an attribute structure used to alter the default server initialization. This will mostly be used in a driver specific manner. can be NULL.
  stack |

## globus_xio_server_get_contact_string()

globus_result_t globus_xio_server_get_contact_string | ( | globus_xio_server_t | server,
|  | char ** | contact_string )

get contact string

This function allows the user to get the contact string for a server. this string could be used as the contact string for the client side.

Parameters

  server | An initialized server handle created with globus_xio_server_create()
  contact_string | an out variable. Will point to a newly allocated string on success. must be freed by the caller.

## globus_xio_server_register_accept()

globus_result_t globus_xio_server_register_accept | ( | globus_xio_server_t | server,
|  | globus_xio_accept_callback_t | cb,
|  | void * | user_arg )

Asynchronous accept.

This function posts an nonblocking accept. Once the operation has completed the user function pointed to by the parameter cb is called.

## globus_xio_server_register_close()

globus_result_t globus_xio_server_register_close | ( | globus_xio_server_t | server,
|  | globus_xio_server_callback_t | cb,
|  | void * | user_arg )

post a close on a server object

This function registers a close operation on a server. When the user function pointed to by parameter cb is called the server object is closed.

## globus_xio_stack_copy()

globus_result_t globus_xio_stack_copy | ( | globus_xio_stack_t * | dst,
|  | globus_xio_stack_t | src )

Copy a stack object

## globus_xio_stack_destroy()

globus_result_t globus_xio_stack_destroy | ( | globus_xio_stack_t | stack | ) |

Destroy a stack object.

## globus_xio_stack_init()

globus_result_t globus_xio_stack_init | ( | globus_xio_stack_t * | stack,
|  | globus_xio_attr_t | stack_attr )

Initialize a stack object

## globus_xio_stack_push_driver()

globus_result_t globus_xio_stack_push_driver | ( | globus_xio_stack_t | stack,
|  | globus_xio_driver_t | driver )

Push a driver onto a stack.

No attrs are associated with a driver. The stack represents the ordered lists of transform drivers and 1 transport driver. The transport driver must be pushed on first.

## globus_xio_write()

globus_result_t globus_xio_write | ( | globus_xio_handle_t | handle,
|  | globus_byte_t * | buffer,
|  | globus_size_t | buffer_length,
|  | globus_size_t | waitforbytes,
|  | globus_size_t * | nbytes,
|  | globus_xio_data_descriptor_t | data_desc )

Write data to a handle

## globus_xio_writev()

globus_result_t globus_xio_writev | ( | globus_xio_handle_t | handle,
|  | globus_xio_iovec_t * | iovec,
|  | int | iovec_count,
|  | globus_size_t | waitforbytes,
|  | globus_size_t * | nbytes,
|  | globus_xio_data_descriptor_t | data_desc )

Write data to a handle from a globus_xio_iovec_t (struct iovec)